{% extends 'base.html.twig' %}

{% block title %}Transactions{% endblock %}

{% block stylesheets %}
    <link href="{{ asset('/css/transactions.css') }}" rel="stylesheet">
    {{ parent() }}
{% endblock %}

{% block body %}

    {% set route = 'app_transactions' %}

    {% set defaultFilters = {
        'search': '',
        'type': 0,
        'category': 0,
    } %}

    {% include 'parts/header.html.twig' with {'selected_item': 'transactions'} %}

    <div class="content overflow">
        <div class="title center-align">
            <h1>Transactions List</h1>
        </div>
        <div class="table-container center-align bg-light" style="width: 1500px;">
            <div class="table-header">
                <div style="margin: 0 auto 2em 2em; padding-top: 1em;">
                    <a id="buttonAdd" class="btn btn-primary" href="{{ path('app_transaction_new') }}">Add transaction</a>
                </div>
                <div style="margin: 1em;">
                    {% include 'parts/search.html.twig' with {
                        'route': route,
                        'search_name': 'search'
                    } | merge(filters) %}
                </div>
                <div style="margin: 1em;">
                    {% include 'parts/select.html.twig' with {
                        'route': route,
                        'select_name': 'type',
                        'selected_value': filters.type,
                        'items': types,
                        'item_type': 'object',
                        'label': 'Type'
                    } | merge(filters) %}
                </div>
                <div style="margin: 1em;">
                    {% include 'parts/select.html.twig' with {
                        'route': route,
                        'select_name': 'category',
                        'selected_value': filters.category,
                        'items': categories,
                        'item_type': 'object',
                        'label': 'Category'
                    } | merge(filters) %}
                </div>
                <div style="margin: 1em;">
                    {% include 'parts/select.html.twig' with {
                        'route': route,
                        'select_name': 'month',
                        'selected_value': filters.month,
                        'items': months,
                        'item_type': 'object',
                        'label': 'Month'
                    } | merge(filters) %}
                </div>
                <div style="margin: 1em;">
                    {% include 'parts/select.html.twig' with {
                        'route': route,
                        'select_name': 'year',
                        'selected_value': filters.year,
                        'items': years,
                        'item_type': 'value',
                        'label': 'Year'
                    } | merge(filters) %}
                </div>
                <div style="margin: 0 auto 2em 2em; padding-top: 1em;">
                    <a class="btn btn-secondary" href="{{ path(route, defaultFilters) }}">Clear Filters</a>
                </div>
            </div>
            <table class = "table">
                <tr>
                    <th style="width: 100px;"></th>
                    <th>Amount</th>
                    <th>Category</th>
                    <th>Comment</th>
                    <th>Date</th>
                    <th style="width: 100px;"></th>
                    <th style="width: 100px;"></th>
                </tr>
                {% for transaction in transactions %}
                    <tr>
                        <td style="width: 100px; text-align: center;">
                            {% if transaction.type.name == 'income' %}
                                <img class="icon" alt="income" title="income" src='{{asset("uploads/icons/plus.png")}}' />
                            {% endif %}
                            {% if transaction.type.name == 'expense' %}
                                <img class="icon" alt="expense" title="expense" src='{{asset("uploads/icons/minus.png")}}' />
                            {% endif %}
                        </td>
                        <td>{{ transaction.amount }}</td>
                        <td>{{ transaction.category.name }}</td>
                        <td>{{ transaction.comment }}</td>
                        <td>{{
                            transaction.executionDate ?
                                transaction.executionDate|date('Y-m-d') :
                                'Undefined'
                        }}</td>
                        <td style="width: 100px;">
                            <a class="btn btn-primary" href="{{ path('app_transaction_update', { 'id': transaction.id }) }}">
                                Edit
                            </a>
                        </td>
                        <td style="width: 100px;">
                            <button type="button" class="btn btn-danger delete-button" onClick="openModalDelete('{{ transaction.id }}')">Delete</button>

                            {% include 'parts/modals/delete_transaction.html.twig' with {'transaction': transaction} %}

                        </td>
                    </tr>
                {% endfor %}
            </table>
            <div class="table-footer">
                <div style="margin-top: 1em;">
                    {% if (pages > 1) %}

                        {% set paginatorVars = {
                            'route': route,
                            'page': page,
                            'pages': pages,
                        } %}

                        {% include 'parts/paginator.html.twig' with {paginatorVars, filters} %}
                    {% else %}
                        &nbsp;
                    {% endif %}
                </div>
                <div style="margin: 1em 2em 0.5em; text-align: right;">
                    <h4><span>
                        {% if total_amount > 0 %}
                            <img class="icon" alt="income" title="income" src='{{asset("uploads/icons/plus.png")}}' />
                        {% endif %}
                        {% if total_amount < 0 %}
                            <img class="icon" alt="expense" title="expense" src='{{asset("uploads/icons/minus.png")}}' />
                        {% endif %}
                    </span>&nbsp; &nbsp; Total: {{ total_amount|number_format(2, '.', ',') }}</h4>
                </div>
            </div>
        </div>
    </div>

    {% include 'parts/footer.html.twig' %}
{% endblock %}

{% block javascripts %}
    <script src="{{ asset('/scripts/delete_transaction_modal.js') }}"></script>
{% endblock %}
